//+------------------------------------------------------------------+
//|                                                    Macd plus.mq4 |
//|                                                 Copyright  2010 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010"

extern int 			MagicNumber	= 3345;	
extern double     Lot = 1;
extern double     LotStart = 1;
extern double SvobDepoStart = 10000;  

extern int			StopLoss					= 600;
extern int			TakeProfit			= 310;	

extern int	fastMA_period	= 10;
extern int	fastMA_method	= 0;
extern int	fastMA_price		= 0;

extern int	slowMA_period	= 1000;
extern int	slowMA_method	= 0;
extern int	slowMA_price		= 0;

extern int FastEMA=6;
extern int SlowEMA=24;
extern int SignalSMA=9;

extern double	N		= 0;
extern double	C		= 0.7;
extern double	D		= 12;
extern double	T		= 0.013;

int  LevelWLoss  = 1; 
int  LevelProfit = 1; 
bool ShowComment = True; 
bool SoundAlert  = True; 
double sl, tp;
int BBars;
bool   fm;
double pBid, pAsk, pp;
int    i, j, k, nd, massind[];
string comm="";


int limit;
double upPrice,downPrice;
double ExtMapBuffer1[];
extern int       Z=15; //   
extern int       X=500; //  
double Buypodem;  


double DepoStop=0;
  
	int iBuyOrders = 0, iSellOrders = 0,	iTicket = 0 ;
	extern int Slippage = 30; 
	
double fastMA_1;
double slowMA_1;
double fastMA_2;
double slowMA_2;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
  
double lotoved=SvobDepoStart/LotStart;
double SvobDepo=NormalizeDouble(AccountBalance()-AccountMargin(),2);  

if (DepoStop<SvobDepo) {
Lot=NormalizeDouble(SvobDepo/lotoved,2);
DepoStop=SvobDepo; }
else
Lot=NormalizeDouble(DepoStop/lotoved,2);

if (Lot>1000) Lot=1000;
//double LotC=Lot/1;
//double LotD=Lot/1;

      upPrice=High[iHighest(Symbol(),0,MODE_HIGH,Z,i)];//  N  
      downPrice=Low[iLowest(Symbol(),0,MODE_LOW,Z,i)]; //  N  
      double Volatiliti=(upPrice-downPrice)/Point;
// TakeProfit=Volatiliti/C;
// StopLoss=Volatiliti/C/D;

//---- macd counted in the 1-st buffer
   double fastMA_2 = iMA(NULL, 0, fastMA_period, 0, fastMA_method, fastMA_price, 1);
	double slowMA_2 = iMA(NULL, 0, slowMA_period, 0, slowMA_method, slowMA_price, 1);
   double MA_s = fastMA_2-slowMA_2;
   
   fastMA_1=iCustom(NULL,0,"MACD_plus",2,1);
//---- signal line counted in the 2-nd buffer
   slowMA_1=iCustom(NULL,0,"MACD_plus",2,2);
//----
   	                        
double Podem=fastMA_1 - slowMA_1;
 if (OrdersTotal() < 10)
   {

if(BBars!=Bars)   {

if(NormalizeDouble(MA_s, Digits) > T)
	  {
if(NormalizeDouble(fastMA_1, Digits) > 0)
	  {
if(NormalizeDouble(slowMA_1, Digits) < 0)
	{ BBars=Bars;
	  
                  if(StopLoss > 0)
				           sl = NormalizeDouble(Bid - StopLoss*Point, Digits);
			        else
				           sl = 0.0;
			        if(TakeProfit > 0)
				           tp = NormalizeDouble(Bid + TakeProfit*Point, Digits);
			        else
				           tp = 0.0;
			        if(OrderSend(Symbol(), OP_BUY, Lot, Ask, 0, sl, tp, 
			           "MA Expert", MagicNumber ) < 0)
				           Alert("   BUY-!!!");
	}
    }}

if(NormalizeDouble(MA_s, Digits) < -T)
	  {       
if(NormalizeDouble(fastMA_1, Digits) < 0)
	  {
if(NormalizeDouble(slowMA_1, Digits) > 0)
	  {BBars=Bars;	
				           
				      if(StopLoss > 0 )
				           sl = NormalizeDouble(Ask + StopLoss*Point, Digits);
			        else
				           sl = 0.0;
			        if(TakeProfit > 0)
				           tp = NormalizeDouble(Ask - TakeProfit*Point, Digits);
			        else
				           tp = 0.0;
			        if(OrderSend(Symbol(), OP_SELL, Lot, Bid, 0, sl, tp, 
			           "MA Expert", MagicNumber) < 0)
				           Alert("   SELL-!!!");
   
   
 } } } } } 
 Buypodem=Podem;  
  // 
//if(BBars!=Bars)   {
//	  int _OrdersTotal = OrdersTotal(); 
//	  bool ExpertOrder = false;
//	  for(int z = _OrdersTotal - 1; z >= 0; z --)
//	    {
//		     if(!OrderSelect(z, SELECT_BY_POS, MODE_TRADES)) 
//		         continue;
//		     if(OrderMagicNumber() != MagicNumber || OrderSymbol() != Symbol()) 
//		         continue;
//		     ExpertOrder = true;
//		     if(OrderType() == OP_BUY)
//		       {
//			   if(NormalizeDouble(fastMA_1, Digits) < 0)
//				             {
//					              if(!OrderClose(OrderTicket(), OrderLots(), Bid, 0, Blue))
//						                 Alert("   BUY-!!!");
//				             }
//			          
//			        continue;
//		       }
 //      if(OrderType() == OP_SELL)
 //        {
 //          if(NormalizeDouble(fastMA_1, Digits) > 0)
//	                {
//		                 if(!OrderClose(OrderTicket(), OrderLots(), Ask, 0, Red))
//			                    Alert("   SELL-!!!");
//	                }
 //            
 //          continue;
//         }
//     }}
     

//----
   return(0);
  }
//+------------------------------------------------------------------+


